//******************************************************
// CAPAX-Xtd Expert : Coffre-fort
// V1.0 Le 14/08/2018
// CAPAX SYSTEMS by www.infoconsult.tn
//******************************************************

#include <Keypad.h>
#include <LiquidCrystal.h>
LiquidCrystal lcd(34,33,32,31,30,29);

const byte LIGNES = 4;
const byte COLONNES = 3;
char touches[LIGNES][COLONNES] = {
  {'1', '2', '3'},
  {'4', '5', '6'},
  {'7', '8', '9'},
  {'*', '0', '#'}
};
byte BrochesLignes[LIGNES] = {36, 39, 40, 38 };
byte BrochesColonnes[COLONNES] = {37, 35, 41};
Keypad clavier = Keypad( makeKeymap(touches), BrochesLignes, BrochesColonnes, LIGNES, COLONNES );
#define led_r 43
#define led_v 42
#define led_j 44
#define buzz 10
int count =0;
String pwd ="";
String pwdCoffre = "2580";
char InputKey;
unsigned int pwdLength;
String pwd1;

void setup() {
  lcd.begin(16,2); 
  pinMode(led_r,OUTPUT);
  pinMode(led_j,OUTPUT);
  pinMode(led_v,OUTPUT);

  lcd.setCursor(0,0);
  lcd.print("Mot de passe");
  lcd.setCursor(15,0);
  lcd.print(count+1);
  lcd.setCursor(0,1);  
  Serial.begin(9600);

}

void loop() {
  if(count==3){
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("System locked");
    digitalWrite(led_r, HIGH);
    digitalWrite(led_j, LOW);
    buzz1();  
    buzz1();  
    buzz1();
    lcd.clear();
    InputKey = clavier.getKey();
    while (InputKey != '#'){
      lcd.setCursor(0,0);
      lcd.print("Appuyer sur '#'");
      lcd.setCursor(0,1);
      lcd.print("pour debloquer");
      InputKey = clavier.getKey();
      }
    count =0;
    digitalWrite(led_r, LOW);
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Mot de passe");
    lcd.setCursor(15,0);
    lcd.print(count+1);
    lcd.setCursor(0,1);  

    }
  else {
    InputKey=clavier.getKey();
    if (InputKey) {

      switch (InputKey) {
        case '*': // efface le dernier caracère
          pwdLength = pwd.length();
          if (pwdLength !=0){
          pwd.remove(pwdLength-1, 1);
          lcd.setCursor(pwdLength-1,1);
          lcd.print(" ");
          lcd.setCursor(pwdLength-1,1);                 
          }
          break;
        case '#':// pour comparer le mot de passe
            if (pwd==pwdCoffre) { // mot de passe correct
              buzz2();
              lcd.setCursor(0,1);
              lcd.print("correct  ");
              delay(1000);
              lcd.clear();
              lcd.setCursor(0,0);
              lcd.print("Welcome Mr");
              lcd.setCursor(0,1);
              lcd.print("no body");
              digitalWrite(led_v,1);
              digitalWrite(led_j,0);
              InputKey = clavier.getKey();
              while (InputKey != '#'){
                lcd.setCursor(0,0);
                lcd.print("Appuyer sur '#'");
                lcd.setCursor(0,1);
                lcd.print("pour refaire");
                InputKey = clavier.getKey();
                }
              digitalWrite(led_v, LOW);
              lcd.clear();
              pwd = "";
              count =0;
              lcd.setCursor(0,0);
              lcd.print("Mot de passe");
              lcd.setCursor(15,0);
              lcd.print(count+1);
              lcd.setCursor(0,1);  
              }
            else { //mot de passe incorrect
              buzz2();
              lcd.setCursor(0,1);
              lcd.print("incorrect ");
              count =count+1;
              pwd="";
              delay(1000);
              if (count == 2) {
                digitalWrite(led_j,1);
              }
              lcd.clear();
              lcd.setCursor(0,0);
              lcd.print("try again loser ");
              delay(1000);
              lcd.clear();
              lcd.setCursor(0,0);
              lcd.print("Mot de passe");
              lcd.setCursor(15,0);
              lcd.print(count+1);
              lcd.setCursor(0,1);
              }

          break;
        default:// en phase d'écriture du mot de passe
          pwd=pwd+InputKey;
          lcd.print('*');
          buzz2();
          break;
      }
     }
    }
} 
  void buzz1 (){
    tone(buzz,989,1000);
    delay(100);
    tone(buzz,100,1000);
    delay(500);
  }
  void buzz2(){
    tone(buzz,500,100);
    delay(100);
  }
 
